AbstractTypeVisitor7 (Java Platform SE 8 )
Keywords: javax.lang.model.util.AbstractTypeVisitor7 class
Date: 2026-04-24

compact3
javax.lang.model.util

## Class AbstractTypeVisitor7<R,P>

- java.lang.Object
- - javax.lang.model.util.AbstractTypeVisitor6<R,P>
  - - javax.lang.model.util.AbstractTypeVisitor7<R,P>

- Type Parameters:
    `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
    `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.
  All Implemented Interfaces:
    TypeVisitor<R,P>
  Direct Known Subclasses:
    AbstractTypeVisitor8

      public abstract class AbstractTypeVisitor7<R,P>
      extends AbstractTypeVisitor6<R,P>

  A skeletal visitor of types with default behavior appropriate for the `RELEASE_7` source version.

  WARNING: The `TypeVisitor` interface implemented by this class may have methods added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

  When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new abstract type visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

  Note that adding a default implementation of a new visit method in a visitor class will occur instead of adding a default method directly in the visitor interface since a Java SE 8 language feature cannot be used to this version of the API since this version is required to be runnable on Java SE 7 implementations. Future versions of the API that are only required to run on Java SE 8 and later may take advantage of default methods in this situation.

  Since:
    1.7
  See Also:
    `AbstractTypeVisitor6`, `AbstractTypeVisitor8`

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractTypeVisitor7()` Constructor for concrete subclasses to call.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract R` | `visitUnion(UnionType t, P p)` Visits a `UnionType` in a manner defined by a subclass.

    - ### Methods inherited from class javax.lang.model.util.AbstractTypeVisitor6

      `visit, visit, visitIntersection, visitUnknown`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.lang.model.type.TypeVisitor

      `visitArray, visitDeclared, visitError, visitExecutable, visitNoType, visitNull, visitPrimitive, visitTypeVariable, visitWildcard`

- - ### Constructor Detail

    - #### AbstractTypeVisitor7

          protected AbstractTypeVisitor7()

      Constructor for concrete subclasses to call.

  - ### Method Detail

    - #### visitUnion

          public abstract R visitUnion(UnionType t,
                                       P p)

      Visits a `UnionType` in a manner defined by a subclass.
      Specified by:
        `visitUnion` in interface `TypeVisitor<R,P>`
      Overrides:
        `visitUnion` in class `AbstractTypeVisitor6<R,P>`
      Parameters:
        `t` - the type to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of the visit as defined by a subclass

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.